Imports System.ComponentModel

' This tab lists only properties in the Test Properties category.
Public Class TestPropertiesTab
    Inherits PropertyTab

    ' Returns only the properties in the Test Properties category.
    Public Overloads Overrides Function GetProperties(ByVal component As Object, ByVal attributes() As System.Attribute) As System.ComponentModel.PropertyDescriptorCollection
        Dim props_in As PropertyDescriptorCollection
        If attributes Is Nothing Then
            props_in = TypeDescriptor.GetProperties(component)
        Else
            props_in = TypeDescriptor.GetProperties(component, attributes)
        End If

        Dim props_out As New PropertyDescriptorCollection(Nothing)
        Dim i As Integer
        For i = 0 To props_in.Count - 1
            If props_in(i).Category = "Test Properties" Then
                ' Create a PropertyDescriptor for this property.
                props_out.Add( _
                    TypeDescriptor.CreateProperty( _
                        props_in(i).ComponentType, _
                        props_in(i), _
                        Nothing) _
                )
            End If
        Next i
        Return props_out
    End Function

    Public Overloads Overrides Function GetProperties(ByVal component As Object) As System.ComponentModel.PropertyDescriptorCollection
        Return Me.GetProperties(component, Nothing)
    End Function

    ' Provides the name for the property tab.
    Public Overrides ReadOnly Property TabName() As String
        Get
            Return "Test Properties"
        End Get
    End Property

    ' Provides an image for the property tab.
    Public Overrides ReadOnly Property Bitmap() As System.Drawing.Bitmap
        Get
            Return My.Resources.TestProperties
        End Get
    End Property
End Class
